theory Fold_Exp
imports "BExp"
begin

text {*
  Write a new function @{term asimp} that simplifies arithmetic expressions
  as in the lecture, but that also performs simplification with 0, e.g.
  the expression @{term "Plus (N 0) (V ''x'')"} should be simplified to 
  @{term "V ''x''"}.
*}

fun asimp :: "aexp => aexp" where
  "asimp (N i) = N i"
(* ... *)

text {*
  Prove that this optimisation is semantics preserving:
*}
lemma asimp:
  "aval (asimp a) s = aval a s"
  oops

text {*
  Now simplify boolean expressions in a similar manner, but simplify
  with the constants @{const True} and @{const False} instead of 0.
  If arithmetic expressions occur, return their simplified form.

  Then state prove that your optimisation is semantics preserving.
*}

(* ... *)

text {*
  Hint: to reduce the number of cases, it may be useful to define a
  separate optimisation function for each constructor. As an example,
  here the function for @{const Plus} implementing the optimisation from
  the lecture.
*}

definition plus where
  "plus a1 a2 \<equiv> case (a1,a2) of 
     (N n1,N n2) => N (n1 + n2)
  |  (a1,a2) => Plus a1 a2"

fun simple_simp where
  "simple_simp (N n) = N n" |
  "simple_simp (V x) = V x" |
  "simple_simp (Plus a1 a2) = plus (simple_simp a1) (simple_simp a2)"

lemma plus[simp]:
  "aval (plus a1 a2) s = aval a1 s + aval a2 s"
  by (simp add: plus_def split: aexp.split)  

lemma simple_simp:
  "aval (simple_simp a) s = aval a s"
  by (induct a) auto

end
